﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.47
@EndOfDesignText@
#if B4A
'ignore DIP related warnings as they are not relevant when working with BitmapCreator.
#IgnoreWarnings: 6
#end if
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
Sub Class_Globals
	Public X2 As X2Utils
	Private xui As XUI 'ignore
	Public world As B2World

	Private ivForeground As B4XView
	Public ivBackground As B4XView
	
	Public lblStats As B4XView
	
	Public TileMap As X2TileMap
	Public Const ObjectLayer As String = "Object Layer 1"
	
	Private GameOver As Boolean
	
	Private ground As X2BodyWrapper
	Public TotalWidth As Float
	Public WorldHeight As Float
	Private WorldWidth As Float
	
	Public RightDown, LeftDown, Q As Boolean
	
	Private Planets(3) As X2BodyWrapper

	Private MouseJoint As MouseJoint 'ignore
	Private PanelForTouch As B4XView
	
End Sub

Public Sub Initialize (Parent As B4XView)
	Parent.LoadLayout( "1" )
	world.Initialize( "world", world.CreateVec2( 0, 0) )
	'
	X2.Initialize(Me, ivForeground, world)
	Dim ratio As Float = ivForeground.Width / ivForeground.Height
	WorldHeight = 30
	TotalWidth = WorldHeight * 1.5
	Dim WorldWidth As Float = WorldHeight * ratio
	X2.ConfigureDimensions( X2.CreateVec2( WorldWidth / 2, WorldHeight / 2 ), WorldWidth * 1 )
'	'
'	X2.PositionIterations = 30
'	X2.VelocityIterations = 30
'	'
	lblStats.TextColor = xui.Color_Black
	lblStats.Color = 0x88ffffff
	lblStats.Font = xui.CreateDefaultBoldFont(20)
	'
	MouseJoint.Initialize(Me)
	'
	'comment to disable debug drawing
	X2.EnableDebugDraw
	'
	'
End Sub

Public Sub Start
	If X2.IsRunning Then Return
	'
	X2.Reset
	'
	GameOver = False
	'
	CreateStaticBackground
	'
	'
	TileMap.Initialize( X2, File.DirAssets, "thing.json", Null )
	TileMap.SetSingleTileDimensionsInMeters(TotalWidth / TileMap.TilesPerRow, WorldHeight / TileMap.TilesPerColumn)
	TileMap.PrepareObjectsDef( ObjectLayer )
	'
'	Ground = TileMap.CreateObject2ByName( ObjectLayer , "ground")
	Dim ol As X2ObjectsLayer = TileMap.Layers.Get( ObjectLayer )
	' 
	Dim i As Int = 0
	For Each template As X2TileObjectTemplate In ol.ObjectsById.Values
		If template.Name.Contains( "template" ) = False Then
	
			Dim bw As X2BodyWrapper = TileMap.CreateObject( template )
			If bw.Name.Contains( "planet" ) Then
				bw.Body.AngularVelocity = cPI/Rnd( 16,32 )
				Planets(i) = bw
				i=i+1

			End If

		End If
	Next
	'
'	X2.SlowDownPhysicsScale = 1
'	X2.UpdateTimeParameters	
	X2.Start
End Sub

Private Sub Game_Over(ft As X2FutureTask)
	'
	' stop and restart
	X2.Stop
	Sleep(100)
	Start 
	'
End Sub

Private Sub CreateStaticBackground
	Dim bc As BitmapCreator
	bc.Initialize(ivBackground.Width / xui.Scale / 2, ivBackground.Height / xui.Scale / 2)
	bc.FillGradient(Array As Int(0xFF006EFF, 0xFF00DAAD), bc.TargetRect, "TOP_BOTTOM")
	X2.SetBitmapWithFitOrFill(ivBackground, bc.Bitmap)
End Sub




Private Sub PanelForTouch_Touch (Action As Int, X As Float, Y As Float)
	X = Max(0, Min(X, PanelForTouch.Width))
	Y = Max(0, Min(Y, PanelForTouch.Height))
	'
	Select Action
		Case PanelForTouch.TOUCH_ACTION_DOWN
			'
			MouseJoint.Create( X,Y )
			'
		Case PanelForTouch.TOUCH_ACTION_MOVE
			'
			MouseJoint.Move( X,Y )
			'
		Case PanelForTouch.TOUCH_ACTION_UP
			'
			MouseJoint.Destroy
			' 
	End Select
	'
End Sub

Public Sub Tick (GS As X2GameStep)
	'
	If GameOver Then Return
	'
	If q Then
		X2.AddFutureTask(Me, "game_over", 500, Null)
		GameOver = True
	End If
	'
	Log ($" ${X2.B2AngleToDegrees(Planets(0).Body.Angle)}"$)
	'
	If GS.ShouldDraw Then
		

	End If
		
End Sub


Public Sub Resize
	X2.ImageViewResized
End Sub

Public Sub DrawingComplete
	TileMap.DrawingComplete
End Sub

'Return True to stop the game loop
Public Sub BeforeTimeStep (GS As X2GameStep) As Boolean
	Return False
End Sub


